<?php

namespace Myriad\CircuitBreaker\Provider;

use Myriad\CircuitBreaker\Store\CacheCircuitBreakerStore;
use Myriad\CircuitBreaker\Store\CircuitBreakerStoreInterface;
use Illuminate\Support\ServiceProvider;

class CircuitBreakerServiceProvider extends ServiceProvider
{
    public $bindings = [
        CircuitBreakerStoreInterface::class => CacheCircuitBreakerStore::class
    ];

    /**
     * Perform post-registration booting of services.
     *
     * @return void
     */
    public function boot()
    {
        $this->publishes([
            __DIR__.'/../Config/circuit_breaker.php' => config_path('circuit_breaker.php'),
        ]);
    }
}
